#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef PI
#define PI 3.1415926
#endif

#define DEFAULT_BATCH   (256)
#define DEFAULT_N       (8*1024)

int main(int argc, char **argv)
{
  int BATCH = DEFAULT_BATCH, N = DEFAULT_N;
  int i, j;
  char *out_file;
  FILE *fp;

  if (argc > 1)
  {
    out_file = argv[1];
  }
  else 
  {
    printf("\nUsage: %s <out_file> [batch_size = %d] [N = %d]\n\n",argv[0],BATCH,N);
    return 0;
  }
  if ( argc > 2 )
    BATCH = atoi(argv[2]);

  if ( argc > 3 )
    N = atoi(argv[3]);

  fp = fopen(out_file, "wb");
  if ( fp == NULL )
  {
    printf("Error opening %s for writing!\n", out_file);
    return (-1);
  }

  for ( i = 0; i < BATCH; i++)
  {
    for ( j = 0; j < N; j++)
    {
      float x = sin(2 * PI * (50+i) * j / (double) N);
      fwrite(&x,sizeof(float),1,fp);
    }
  }

  fclose(fp);

  return 0;
}
